"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.requireModuleExports = exports.runCjs = void 0;
const node_fs_1 = __importDefault(require("node:fs"));
const node_path_1 = require("node:path");
const esbuild_1 = require("esbuild");
function runCjs(filePath, code) {
    const dir = (0, node_path_1.dirname)(filePath);
    const fileName = (0, node_path_1.basename)(filePath);
    const ext = (0, node_path_1.extname)(fileName);
    const fileBase = `${fileName}.timestamp-${Date.now()}-${Math.random().toString(16).slice(2)}`;
    const tmpFilePath = (0, node_path_1.join)(dir, fileBase + ext);
    // TODO: support .mjs
    node_fs_1.default.writeFileSync(tmpFilePath, code, 'utf-8');
    const exports = require(tmpFilePath);
    node_fs_1.default.unlinkSync(tmpFilePath);
    if (exports.__esModule) {
        return exports.default;
    }
    return exports;
}
exports.runCjs = runCjs;
/**
 * 读取并运行文件
 */
const requireModuleExports = (filePath) => {
    const result = (0, esbuild_1.buildSync)({
        entryPoints: [filePath],
        bundle: true,
        minify: true,
        platform: 'node',
        format: 'cjs',
        target: 'es2015',
        sourcemap: false,
        write: false,
    });
    const code = result.outputFiles[0].text;
    return runCjs(filePath, code);
};
exports.requireModuleExports = requireModuleExports;
